﻿# foobar2000 動画再生用コンポーネント

## foo_video「Chimera」 (旧「Local Video Player」)

### 2019/04/13 Ver.0.5.0.2

* アップデートの解説

  お久しぶりです。
  桜が咲き乱れ春を感じますが、まだまだ寒いですね。
  風邪など召されませぬよう、ご自愛下さい。

  * Ver.0.5.0.2

    * Pathにマルチバイト文字が含まれた.mkv, .webmファイルを開くとfoobar2000が落ちるバグを修正しました。

* 概要

  foo_videoをダウンロードありがとうございます。
  このコンポーネントはfoobar2000 Ver.1.4で動くように作られています。
  私はC++どころかプログラミングすらやったことがない身なので、上手く実行できるか分かりません。
  そこらへんは自己責任ということでよろしくお願いします。
  残念ですが私以外の配布は禁止です。

  さて、このコンポーネントは動画を再生するコンポーネントです。
  foobar2000が曲を再生したときに、AdvancedConfigに書かれた拡張子がファイルの名前に入っていたら、そのファイルを動画として読み込みます。
  実はDirectShowでコーデックを読み込んでいるので、対応したコーデックがあれば[.flv]とかも読み込むことができます。
  しかし私の技術不足で、ファイルが動画かどうか検出するプログラムを書くことが出来ませんでした。

  なんか動かないな？と思ったらConsoleを見てください。
  Consoleは View->Console で起動できます。
  foo_videoが出す情報は
  foo_video[Info/Warning/Error]:(情報)
  と出ていると思います。
  foo_video[Error]:
  と書いてある部分を探して、その情報を頼りにMSDNで検索をかけてみて下さい。
  サポートしているコーデックはLAV_Filtersとffdshow tryoutsです。
  Ver0.3.X.XからVSFilter(字幕)も対応しました。

  実はfoo_videoの動画プレイヤーとfoobar2000の音声は全く繋がっていません。
  なので音ズレをする可能性がかなり高いです。
  実際余裕で音ズレをするので、目分量で動画に遅延を送り上手く合わせていましたが、Ver.0.4.2.0のアップデートで準備が出来るまでポーズするようになりました。
  ズレが起きる場合には、AdvancedConfig->Local Video Playerで変更できるようにしています。
  これはYoutube Source(別の作者のコンポーネント)においても言えることなんですが、
  DSPにSkip Silence系を入れると音ズレが発生します。
  多少面倒くさいと思いますが、動画を観る際はDSPから抜くことをお勧めします。

* 既知のバグ・不具合

  * 音ズレがする。(Ver.0.5.0.0にて改善?)
  * 一時停止した状態でフルスクリーンにしたり解除すると動画プレイヤーが真っ白になる。(再開すると直る)->redraw* をすれば良いのでは?
  * 動画を再生しているときはファイルに書き込むことが出来ない。(ReplayGain Scanが使えない、タグに書き込めない等々)
  * foo_youtubeとmadVRの相性が悪い。

* 更新履歴
  * Ver.0.1.0.0 2016/08/21 初版
  * Ver.0.1.0.1 2016/08/21 foobar2000正常終了時に何も書いてないクラッシュレポートが出てくる不具合を改善しました。
  * Ver.0.1.1.0 2016/09/04 Advancedに設定を追加し、遅延の設定を個人で調整出来るようにしました。
  * Ver.0.1.2.0 2016/09/05 Advancedに設定を追加し、動画プレイヤーを常に最前面にするオプションを追加しました。
  * Ver.0.1.2.1 2016/09/05 動画プレイヤーを再生するときに必ず前面に来るようにしました。
  * Ver.0.2.0.0 2016/11/10 ビデオレンダラをEnhanced Video Rendererにしました。
  * Ver.0.2.1.0 2016/12/03 ダブルクリックの動作を最大化からフルスクリーンにしました。
  * Ver.0.2.1.1 2016/12/04 hydrogenaud.ioに公開しました。
  * Ver.0.3.0.0 2016/12/30 コーデックを優先しました。(ほぼ非公開)
  * Ver.0.3.1.0 2017/01/03 Advancedに設定を追加し、動画プレイヤーの表示、動画プレイヤーの位置と大きさの指定出来るようにしました。
  * Ver.0.3.1.1 2017/02/16 カーソル全般のバグを修正しました。
  * Ver.0.3.2.0 2017/05/06 要望を実装しました。スレッドの部分を書き直しました。
  * Ver.0.4.0.0 2017/05/24 ウィンドウが続けて再生されるようにしました。madVRに対応しました。名前をChimeraに変更しました。
  * Ver.0.4.1.0 2017/05/27 タイトルバーを消すオプションを追加しました。
  * Ver.0.4.1.1 2017/06/06 アスペクト比が違う動画を連続してみた際に、黒帯が残ってしまうバグを修正しました。
  * Ver.0.4.2.0 2017/12/16 動画再生時にポーズをするようになりました。
  * Ver.0.4.3.0 2017/12/28 AdvancedConfigに拡張子のリストを追加しました。
  * Ver.0.5.0.0 2018/04/15 Preferenceページの作成、Matroskaチャプターの対応をしました。
  * Ver.0.5.0.1 2018/07/25 VSFilterが動くように修正
  * Ver.0.5.0.2 2019/04/13 Pathにマルチバイト文字が含まれた時、foobar2000が落ちるバグを修正。

* アップデート予定(夢物語)
  * (完) 設定画面を作り、その中に遅延の設定を個人が出来るようにする
  * (完) OFFの間は動画を再生しないようにするトグルスイッチを追加
  * (完) 動画プレイヤーを常に前に出すオプションを追加
  * ↑より弱い最前面オプションを追加
  * (完) \[.mp4\]と\[.mkv\]以外にも動画を再生出来るようにする
  * (完)↑の拡張子を追加できるようにした。
  * プレイヤーに右クリックメニューを追加して、同期などのボタンを追加
  * (完) ビデオレンダラをVMR9(Windowless)からEVRに変更(Windows XPはサポートしません)
  * (完) 全画面(フルスクリーン)機能を追加
  * プレイヤーにシークバーを追加
  * シークバーにマウスオーバーした際にサムネを表示
  * (完) 動画に入っている字幕の表示
  * DVD/BDの動画再生
  * 音声フォルダに埋め込まれているLyricsタグを字幕として表示
  * 自動アップデート通知の追加
  * 日本語と英語で言語切り替え機能の追加
  * 動画再生中のみDSPを変更する機能の追加
  * (完) もう一つのビデオレンダラとしてmadVRを選択出来るようにする
  * (Matroskaのみ) チャプター情報がついている動画の対応
  * 動画プレイヤーのPanel化

* 最後に

  前回のアップデートから時間がかかっていますが、これは私がやりたいことがたくさんあったからです。
  2019/05/01(令和元年！)に、自分が組み込んだDSPプリセット(クロスフィード)を公開出来れば良いと思っています。
  
---

* クレジット

  * 作者

    FuCrowRabbit (Rabbit Melody Studio)

  * TwitterID

    @FuCrowRabbit
	
    ↑質問や生存確認はこのTwitterからどうぞ。

  * Webサイト

    https://ramest.net/FuCrowRabbit/